
package panel;

import Connection.ConnectionDB;
import PlugIn.SubDefaultTableModel;
import database.GuestDB;
import database.StoreDB;
import java.awt.Font;
import javax.swing.JOptionPane;
import java.sql.*;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;
import resources.Component;
import resources.Guest;
/**
 *
 * @author CHINDA
 */
public class InforGuestDetail extends javax.swing.JPanel {

    /**
     * Creates new form ShowDetail
     */
    private SubDefaultTableModel mod;
    public InforGuestDetail() {
        initComponents();
        com = new Component();
        mod = new SubDefaultTableModel(null,new Object[]{com.getRb().getString("lbNo"),com.getRb().getString("lbGuestId"),com.getRb().getString("lbName"),
            com.getRb().getString("lbGender"),com.getRb().getString("lbVillage"),com.getRb().getString("lbRiel"),com.getRb().getString("lbDollar"),
            com.getRb().getString("lbDong"),com.getRb().getString("lbDate"),com.getRb().getString("lbFamily"),com.getRb().getString("lbOther")});
        tbl.setModel(mod);
        getvillage();
        com.setLable(new String[]{"lbInforGuestDetailTitle","lbVillage","lbSearchName"}, lbInforGuestDetailTitle,lbVillage,lbSearchVillage);
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lbInforGuestDetailTitle = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        lbSearchVillage = new javax.swing.JLabel();
        txtSearchName = new javax.swing.JTextField();
        lbVillage = new javax.swing.JLabel();
        cmbVillage = new javax.swing.JComboBox<>();
        jScrollPane2 = new javax.swing.JScrollPane();
        tbl = new PlugIn.SubJTable();

        setBackground(java.awt.Color.white);

        lbInforGuestDetailTitle.setFont(new java.awt.Font("Khmer OS Battambang", 1, 24)); // NOI18N
        lbInforGuestDetailTitle.setForeground(new java.awt.Color(204, 0, 0));
        lbInforGuestDetailTitle.setText("ពត៌មានលម្អិត");

        jSeparator1.setForeground(new java.awt.Color(0, 255, 0));

        lbSearchVillage.setFont(new java.awt.Font("Khmer OS Battambang", 1, 14)); // NOI18N
        lbSearchVillage.setText("ស្វែងរកឈ្មោះ");

        txtSearchName.setFont(new java.awt.Font("Khmer OS Battambang", 1, 14)); // NOI18N
        txtSearchName.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                txtSearchNameCaretUpdate(evt);
            }
        });

        lbVillage.setFont(new java.awt.Font("Khmer OS Battambang", 1, 14)); // NOI18N
        lbVillage.setText("ឈ្មោះភូមិ");

        cmbVillage.setFont(new java.awt.Font("Khmer OS Battambang", 1, 14)); // NOI18N
        cmbVillage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbVillageActionPerformed(evt);
            }
        });

        tbl.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        tbl.setColorSelected(new java.awt.Color(51, 204, 255));
        tbl.setFont(new java.awt.Font("Khmer OS Battambang", 0, 12)); // NOI18N
        tbl.setRowHeight(30);
        tbl.setSelectionBackground(new java.awt.Color(51, 255, 255));
        tbl.getTableHeader().setResizingAllowed(false);
        tbl.getTableHeader().setReorderingAllowed(false);
        jScrollPane2.setViewportView(tbl);
        tbl.setFontHeader(new Font("Khmer OS Battambang",Font.BOLD,15));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(16, 16, 16)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 553, Short.MAX_VALUE)
                    .addComponent(lbInforGuestDetailTitle, javax.swing.GroupLayout.PREFERRED_SIZE, 420, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 298, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(lbVillage, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(5, 5, 5)
                        .addComponent(cmbVillage, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(lbSearchVillage, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(5, 5, 5)
                        .addComponent(txtSearchName, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(16, 16, 16))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addComponent(lbInforGuestDetailTitle, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(6, 6, 6)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(6, 6, 6)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(3, 3, 3)
                        .addComponent(lbVillage))
                    .addComponent(cmbVillage, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(6, 6, 6)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(3, 3, 3)
                        .addComponent(lbSearchVillage))
                    .addComponent(txtSearchName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(12, 12, 12)
                .addComponent(jScrollPane2))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void txtSearchNameCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_txtSearchNameCaretUpdate
       List<Guest> list = ls.getFilterName(txtSearchName.getText().trim());
       DecimalFormat df = new DecimalFormat("#,##0.00");
       mod.removeAllRows();
       for(int i=0; i<list.size(); i++)
           mod.addRow(new Object[]{i+1,list.get(i).getId(),list.get(i).getName(),list.get(i).getGender(),list.get(i).getVillage(),df.format(list.get(i).getReil())
           ,df.format(list.get(i).getDollar()),df.format(list.get(i).getDong()),list.get(i).getDate(),list.get(i).getfId(),list.get(i).getOther()});
        
    }//GEN-LAST:event_txtSearchNameCaretUpdate

    private void cmbVillageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbVillageActionPerformed
       String sql;
       String village = cmbVillage.getSelectedItem()+"".trim();
       if(village.isBlank())
           sql = "select * from view_guest_detail";
       else
           sql = "select * from view_guest_detail where village ='"+village+"'  ";
       getDatabase(sql);
       
    }//GEN-LAST:event_cmbVillageActionPerformed
    //String sql = "select * from viewguestdetail";
    private void getDatabase(String sql){
        try {
            Statement s = ConnectionDB.getDataCon().createStatement(1004,1008);
            ResultSet r = s.executeQuery(sql);
            DecimalFormat df = new DecimalFormat("#,##0.00");
            mod.removeAllRows();
            ls.removeAll();
            if(r.first()){
                int count = 1;
                do{
                    
                    ls.add(new Guest(r.getInt(1), r.getString(2), r.getString(3), r.getString(4),
                            r.getDouble(5), r.getDouble(6), r.getDouble(7), 
                            r.getString(8), r.getInt(9),r.getString(10)));
                    mod.addRow(new Object[]{count,r.getInt(1), r.getString(2), r.getString(3), r.getString(4),
                            df.format(r.getDouble(5)), df.format(r.getDouble(6)), df.format(r.getDouble(7)),
                            r.getString(8), r.getInt(9),r.getString(10)});
                    count++;
                }while(r.next());
            r.close();
            s.close();
            }
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
    }
    
    private void getvillage(){
        String sql = "SELECT distinct village FROM view_guest_detail;";
        try {
            Statement s = ConnectionDB.getDataCon().createStatement(1004, 1008);
            ResultSet r = s.executeQuery(sql);
            cmbVillage.addItem("");
            while(r.next())    
               cmbVillage.addItem(r.getString(1));
            r.close();
            s.close();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
    }
    private Component com;
    private List<String> lsVillage = new ArrayList<>();
    private StoreDB<Guest> ls = new GuestDB();
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> cmbVillage;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JLabel lbInforGuestDetailTitle;
    private javax.swing.JLabel lbSearchVillage;
    private javax.swing.JLabel lbVillage;
    private PlugIn.SubJTable tbl;
    private javax.swing.JTextField txtSearchName;
    // End of variables declaration//GEN-END:variables
}
